﻿// Generated by Xamasoft JSON Class Generator
// http://www.xamasoft.com/json-class-generator

using System;
using System.Collections.Generic;
using System.Reflection;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace SYM.Crawler_DBPedia
{
    public class SingleValueArrayConverter<T> : JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            object retVal = new Object();
            if (reader.Path == "@graph[0].gruppo")
            {
                if (reader.TokenType == JsonToken.StartObject)
                {
                    GruppoObject instance = (GruppoObject)serializer.Deserialize(reader, typeof(GruppoObject));
                    retVal = instance.Value;
                }
                else
                    retVal = reader.Value;
            }
            else if (reader.TokenType == JsonToken.String || reader.TokenType == JsonToken.Integer || reader.TokenType == JsonToken.StartObject)
            {
                T instance = (T)serializer.Deserialize(reader, typeof(T));
                retVal = new List<T>() { instance };
            }
            else if (reader.TokenType == JsonToken.StartArray)
            {
                retVal = serializer.Deserialize(reader, objectType);
            }
            return retVal;
        }

        public override bool CanConvert(Type objectType)
        {
            return false;
        }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Abstract
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class GruppoObject
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Alpinistaprimasalita
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Altrinomi
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Autore
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Cid
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Città
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Codice
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Editore
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Gruppo
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class ImageText
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Immagine
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Nomemontagna
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class SiglaPaese
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Sottogruppo
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Titolo
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Comment
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Label
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Name
    {

        [JsonProperty("@language")]
        public string Language { get; set; }

        [JsonProperty("@value")]
        public string Value { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class Graph
    {

        [JsonProperty("@id")]
        public string Id { get; set; }

        [JsonProperty("@type")]
        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        public List<string> Type { get; set; }

        [JsonProperty("abstract")]
        public Abstract Abstract { get; set; }

        [JsonProperty("alpsMainPart")]
        public string AlpsMainPart { get; set; }

        [JsonProperty("alpsMajorSector")]
        public string AlpsMajorSector { get; set; }

        [JsonProperty("alpsSection")]
        public string AlpsSection { get; set; }

        [JsonProperty("ontology:alpsSoiusaCode")]
        public string OntologyAlpsSoiusaCode { get; set; }

        [JsonProperty("alpsSubsection")]
        public string AlpsSubsection { get; set; }

        [JsonProperty("alpsSupergroup")]
        public string AlpsSupergroup { get; set; }

        [JsonProperty("ontology:elevation")]
        public double OntologyElevation { get; set; }

        [JsonProperty("firstAscentPerson")]
        public string FirstAscentPerson { get; set; }

        [JsonProperty("firstAscentYear")]
        public string FirstAscentYear { get; set; }

        [JsonProperty("ontology:iso31661Code")]
        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        public List<string> OntologyIso31661Code { get; set; }

        [JsonProperty("mountainRange")]
        public string MountainRange { get; set; }

        [JsonProperty("thumbnail")]
        public string Thumbnail { get; set; }

        [JsonProperty("wikiPageExternalLink")]
        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        public List<string> WikiPageExternalLink { get; set; }

        [JsonProperty("ontology:wikiPageID")]
        public int OntologyWikiPageID { get; set; }

        [JsonProperty("ontology:wikiPageLength")]
        public int OntologyWikiPageLength { get; set; }

        [JsonProperty("alpinistaprimasalita")]
        public Alpinistaprimasalita Alpinistaprimasalita { get; set; }

        [JsonProperty("property:altezza")]
        public float PropertyAltezza { get; set; }

        [JsonProperty("altrinomi")]
        [JsonConverter(typeof(SingleValueArrayConverter<Altrinomi>))]
        public List<Altrinomi> Altrinomi { get; set; }

        [JsonProperty("property:anno")]
        [JsonConverter(typeof(SingleValueArrayConverter<int>))]
        public List<int> PropertyAnno { get; set; }

        [JsonProperty("autore")]
        [JsonConverter(typeof(SingleValueArrayConverter<Autore>))]
        public List<Autore> Autore { get; set; }

        //[JsonProperty("catenamontuosa")]
        //public string Catenamontuosa { get; set; }

        [JsonProperty("cid")]
        [JsonConverter(typeof(SingleValueArrayConverter<Cid>))]
        public List<Cid> Cid { get; set; }

        [JsonProperty("città")]
        [JsonConverter(typeof(SingleValueArrayConverter<Città>))]
        public List<Città> Città { get; set; }

        [JsonProperty("codice")]
        public Codice Codice { get; set; }

        [JsonProperty("dataprimasalita")]
        public string Dataprimasalita { get; set; }

        [JsonProperty("editore")]
        [JsonConverter(typeof(SingleValueArrayConverter<Editore>))]
        public List<Editore> Editore { get; set; }

        [JsonProperty("grandeparte")]
        public string Grandeparte { get; set; }

        [JsonProperty("grandesettore")]
        public string Grandesettore { get; set; }

        [JsonProperty("gruppo")]
        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        public string Gruppo { get; set; }

        [JsonProperty("imageText")]
        public ImageText ImageText { get; set; }

        [JsonProperty("immagine")]
        public Immagine Immagine { get; set; }

        [JsonProperty("property:latitudineD")]
        public int PropertyLatitudineD { get; set; }

        [JsonProperty("property:longitudineD")]
        public int PropertyLongitudineD { get; set; }

        //[JsonProperty("nomemontagna")]
        //public Nomemontagna Nomemontagna { get; set; }

        [JsonProperty("sezione")]
        public string Sezione { get; set; }

        [JsonProperty("siglaPaese")]
        public SiglaPaese SiglaPaese { get; set; }

        [JsonProperty("sottogruppo")]
        public Sottogruppo Sottogruppo { get; set; }

        //[JsonProperty("sottosezione")]
        //public string Sottosezione { get; set; }

        [JsonProperty("supergruppo")]
        public string Supergruppo { get; set; }

        [JsonProperty("titolo")]
        [JsonConverter(typeof(SingleValueArrayConverter<Titolo>))]
        public List<Titolo> Titolo { get; set; }

        [JsonProperty("subject")]
        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        public List<string> Subject { get; set; }

        [JsonProperty("georss:point")]
        public string GeorssPoint { get; set; }

        [JsonProperty("comment")]
        public Comment Comment { get; set; }

        [JsonProperty("label")]
        public Label Label { get; set; }

        [JsonConverter(typeof(SingleValueArrayConverter<string>))]
        [JsonProperty("sameAs")]
        public List<string> SameAs { get; set; }

        [JsonProperty("lat")]
        public string Lat { get; set; }

        [JsonProperty("long")]
        public string Long { get; set; }

        [JsonProperty("wasDerivedFrom")]
        public string WasDerivedFrom { get; set; }

        [JsonProperty("depiction")]
        public string Depiction { get; set; }

        [JsonProperty("isPrimaryTopicOf")]
        public string IsPrimaryTopicOf { get; set; }

        [JsonProperty("name")]
        [JsonConverter(typeof(SingleValueArrayConverter<Name>))]
        public List<Name> Name { get; set; }
    }

    [Obfuscation(Feature = "trigger", Exclude = false)]
    public class DBPedia_Mountain
    {
        [JsonProperty("@graph")]
        public Graph[] Graph { get; set; }
    }

}
